program
  map
    module('Win API')                                                 ! Windows API prototypes
      DOSBeep(Long dwFreq, Long dwDuration),Long,Raw,Pascal,Name ('Beep'),Proc ! Beep: Proc so we don't have to worry about return data
    .                                                                 ! End of API prototypes
    MorseCode         (string PassedSendString, <long PassedTone>, <long PassedDit>) ! Sends a string
    SendCodedLetter   (*cstring PassedCodedLetter)                    ! Sends actual dits & dahs: Space, hypehen and period recognized
    SendLetter        (string PassedLetter)                           ! Translates a letter into dits & dahs
  .                                                                   !
GlobalGroup                 group, pre(glo)                           !
Dit                           long                                    ! Length of a dit
NoTone                        long                                    ! Tone used for no tone (set too high to hear)
Tone                          long                                    ! Tone to send
                            end                                       !
DOSFile         file,driver('DOS'),pre(dos)                           ! For reading a file
Record            record                                              !
Data                byte                                              ! Single byte record
                  end                                                 !
                end                                                   !
  code                                                                !
  if command('1')                                                     ! If there is any command line
    if command('2')                                                   ! If tone sent
      glo:Tone = command('2')                                         ! Use it
    else                                                              ! Otherwise...
      glo:Tone = 2500                                                 ! Set default
    .                                                                 ! End of testing for 2nd parameter
    if command('3')                                                   ! If dit time (speed) sent
      glo:Dit = Command('3')                                          ! Use it
    else                                                              ! Otherwise...
      glo:Dit = 75                                                    ! Set default (~8 wpm)
    .                                                                 ! End of testing for 3rd parameter
    if sub(command('1'),1,1) = '!'                                    ! Test for passed file flag
      DOSFile{Prop:Name} = sub(Command('1'),2,255)                    ! Set the file name
      open(DOSFile)                                                   ! Open the file
      if errorcode()                                                  ! Test for file open error
        MorseCode(clip(DOSFile{Prop:Name}) & ' Error: ' & errorcode() & ': ' & error()) ! Complain
      .                                                               ! End of testing for file open error
      set(DOSFile)                                                    ! Start at the beginning of the file
      loop                                                            ! Loop
        next(DOSFile)                                                 ! Get a character
        if dos:Data = 1ah or errorcode() then break end               ! Test for end of file: break
        SendLetter(chr(dos:data))                                     ! Send an individual letter
      .                                                               ! End of loop
    else                                                              ! Otherwise, send text "as is"
      MorseCode(command('1'),command('2'),command('3'))               ! Send command to code procedure
    .                                                                 ! End of testing for whether we're to send a file or straight text
  else                                                                ! Otherwise, no command line sent
    MorseCode('de wb9fmc www.pinrod.com - No data')                                           ! Complain
  .                                                                   ! End of testing for command line
!______________________________________________________________________________
MorseCode            PROCEDURE  (string PassedSendString, <long PassedTone>, <long PassedDit>) ! Declare Procedure
          itemize(1)                                                  !
pos:PassedSendString                    equate                        !
pos:PassedTone                          equate                        !
pos:PassedDit                           equate                        !
          end                                                         !
  CODE                                                                !
  if omitted(pos:PassedTone) or PassedTone = 0                        ! If no tone passed or zero tone
    glo:Tone = 2500                                                   ! Use default
  else                                                                ! Otherwise...
    glo:Tone = PassedTone                                             ! Use passed
  .                                                                   ! End of testing for passed tone
  if omitted(pos:PassedDit) or PassedDit = 0                          ! If no dit time or dit time zero
    glo:Dit = 75                                                      ! Use default (~8 wpm)
  else                                                                ! Otherwise...
    glo:Dit = PassedDit                                               ! Use passed
  .                                                                   ! End of testing for passed dit time
  glo:NoTone = 30000                                                  ! Set the no-tone "tone" (out of hearing range)
  SendLetter(' ')                                                     ! Prefix with a space
  loop i# = 1 to len(clip(PassedSendString))                          ! Loop through the passed string
    SendLetter(PassedSendString[i#])                                  ! Send an individual letter
  .                                                                   ! End of looping through the passed string
!______________________________________________________________________________
SendLetter procedure(string PassedLetter)                             !
sl:Code             cstring(50)                                       ! Code passed to SendCodedLetter
sl:LastCharacter    string(1), static                                 ! Used to supress multiple spaces
sl:SendCharacter    string(1)                                         ! The actual character to send
  code                                                                !
  sl:SendCharacter = PassedLetter[1]                                  ! Get just the first character (in case the string is longer than one character)
  case val(sl:SendCharacter)                                          ! Decisions according to the character value
  of 0h to 020h                                                       ! Control characters (including space)
  orof 07fh to 0ffh                                                   ! Control characters (upper bit & del)
    sl:SendCharacter = ' '                                            ! Force to space
  .                                                                   ! End of surpressing control characters
  if sl:LastCharacter = ' ' and sl:SendCharacter = ' ' then return end ! If we just sent a space, don't send another
  sl:LastCharacter = sl:SendCharacter                                 ! Remember this character
  execute val(Upper(sl:SendCharacter)) - 1fh                          ! According to the value, set the code to be passed to SendCodedLetter
    sl:Code = ' '                                                     ! 20: Space
    sl:Code = ''                                                      ! 21: !
    sl:Code = '.-..-.'                                                ! 22: "
    sl:Code = ''                                                      ! 23: #
    sl:Code = ''                                                      ! 24: $
    sl:Code = ''                                                      ! 25: %
    sl:Code = ''                                                      ! 26: &
    sl:Code = '.----.'                                                ! 27: '
    sl:Code = '-.--.- '                                               ! 28: (
    sl:Code = '-.--.-'                                                ! 29: )
    sl:Code = ''                                                      ! 2a: *
    sl:Code = ''                                                      ! 2b: +
    sl:Code = '--..--'                                                ! 2c: ,
    sl:Code = '-....-'                                                ! 2d: -
    sl:Code = '.-.-.-'                                                ! 2e: .
    sl:Code = '-..-.'                                                 ! 2f: /
    sl:Code = '-----'                                                 ! 30: 0
    sl:Code = '.----'                                                 ! 31: 1
    sl:Code = '..---'                                                 ! 32: 2
    sl:Code = '...--'                                                 ! 33: 3
    sl:Code = '....-'                                                 ! 34: 4
    sl:Code = '.....'                                                 ! 35: 5
    sl:Code = '-....'                                                 ! 36: 6
    sl:Code = '--...'                                                 ! 37: 7
    sl:Code = '---..'                                                 ! 38: 8
    sl:Code = '----.'                                                 ! 39: 9
    sl:Code = '---...'                                                ! 3a: :
    sl:Code = ''                                                      ! 3b: ;
    sl:Code = ''                                                      ! 3c: <
    sl:Code = '-...- '                                                ! 3d: =
    sl:Code = ''                                                      ! 3e: >
    sl:Code = '..--..'                                                ! 3f: ?
    sl:Code = '.--.-.'                                                ! 40: @
    sl:Code = '.-'                                                    ! 41: A
    sl:Code = '-...'                                                  ! 42: B
    sl:Code = '-.-.'                                                  ! 43: C
    sl:Code = '-..'                                                   ! 44: D
    sl:Code = '.'                                                     ! 45: E
    sl:Code = '..-.'                                                  ! 46: F
    sl:Code = '--.'                                                   ! 47: G
    sl:Code = '....'                                                  ! 48: H
    sl:Code = '..'                                                    ! 49: I
    sl:Code = '.---'                                                  ! 4a: J
    sl:Code = '-.-'                                                   ! 4b: K
    sl:Code = '.-..'                                                  ! 4c: L
    sl:Code = '--'                                                    ! 4d: M
    sl:Code = '-.'                                                    ! 4e: N
    sl:Code = '---'                                                   ! 4f: O
    sl:Code = '.--.'                                                  ! 50: P
    sl:Code = '--.-'                                                  ! 51: Q
    sl:Code = '.-.'                                                   ! 51: R
    sl:Code = '...'                                                   ! 51: S
    sl:Code = '-'                                                     ! 51: T
    sl:Code = '..-'                                                   ! 51: U
    sl:Code = '...-'                                                  ! 51: V
    sl:Code = '.--'                                                   ! 51: W
    sl:Code = '-..-'                                                  ! 51: X
    sl:Code = '-.--'                                                  ! 51: Y
    sl:Code = '--..'                                                  ! 51: Z
    sl:Code = ''                                                      ! 51: [
    sl:Code = '-..-.'                                                 ! 51: \
    sl:Code = ''                                                      ! 51: ]
    sl:Code = ''                                                      ! 51: ^
    sl:Code = '..--.-'                                                ! 51: _
  else                                                                ! Otherwise, out of range
    sl:Code = ''                                                      ! Surpress character
  .                                                                   ! End of encodeing character
  if len(sl:Code)                                                     ! If there is a character to send
    SendCodedLetter(sl:Code)                                          ! Send it
  .                                                                   ! End of testing for whether a character should be sent or not
!______________________________________________________________________________
SendCodedLetter     procedure (*cstring PassedCodedLetter)            !
  code                                                                !
  glo:NoTone = 30000                                                  ! Just in case it's not already set
  loop j# = 1 to len(PassedCodedLetter)                               ! Step through all the encoded characters
    case PassedCodedLetter[j#]                                        ! According to the encodeing character
    of '.'                                                            ! "Dit"
      DosBeep(glo:Tone,glo:Dit)                                       ! Send an audible for dit length of time
    of '-'                                                            ! "Dah"
      DosBeep(glo:Tone,glo:Dit * 3)                                   ! Send an audible for 3X dit length of time
    of ' '                                                            ! Space
      DosBeep(glo:NoTone,glo:Dit * 2)                                 ! Send an inaudible for 2X dit length (3rd part added below)
    .                                                                 ! End of decisions according to what encoded character
    DosBeep(glo:NoTone,glo:Dit)                                       ! Force a did length inaudable (space between code elements)
  .                                                                   ! End of looping through encoded characters
  DosBeep(glo:NoTone,glo:Dit * 2)                                     ! Force 2x Dit time inaudable (space beteen code characters)
